print("api.lua ...")

_cuz_module_meta = {
    __index = function(self,k)
        return cuz_params_get(k)
    end,
    __newindex = function(self,k,v)
        cuz_params_set(k,v)
    end,
}

cuz = {
    file_load = cuz_file_load,
    file_save = cuz_file_save,
    view_set = cuz_view_set,
    image_init = cuz_image_init,
    image_draw = cuz_image_draw,
    sample_play = cuz_sample_play,
    stream_play = cuz_stream_play,
    stream_stop = cuz_stream_stop,
    font_draw = cuz_font_draw,
    font_size = cuz_font_size,
    ext_call = cuz_ext_call,
}
    
setmetatable(cuz,_cuz_module_meta)

function _init() init() end
function _loop(t) loop(t) end
function _event(e) event(e) end
function _paint() paint() end

function _strict_init()
    local G = _ENV or _G
    local globals = {}
    local setmetatable = setmetatable
    local rawset = rawset
    local error = error
    local mt = getmetatable(G)
    function strict(enable)
        setmetatable(G,mt)
        if enable ~= true then return end
        setmetatable(G,{
            __newindex = function(self,k,v)
                if type(v) == "function" or globals[k] ~= nil then
                    rawset(self,k,v)
                else
                    error("undeclared global '"..k.."'")
                end
            end,
        })
    end
    function global(k)
        globals[k] = true
    end
    G["_strict_init"] = nil
end
_strict_init()