function Axe_new(scene,tile)
    local x = tile.x
    local y = tile.y
    scene.tilemap:set(x,y,0)
    x = x * GAME.TW
    y = y * GAME.TH
    local obj = Axe(scene,x,y,tile.dx,tile.dy)
    scene:add(obj)
end

class("Axe",Sprite)
function Axe:init(scene,x,y,dx,dy)
    Sprite.init(self,"axe-0",Rect(x+4,y+4,8,8),Rect(-4,-4,16,16))
    self.dx = dx
    self.dy = dy
    self.t = 0 
    self._rect = self.rect:copy()
end
function Axe:loop(scene,t)
    local v = 80
    self.rect.x = self.rect.x + self.dx * v * t
    self.rect.y = self.rect.y + self.dy * v * t
    
    self.image = 'axe-'..(math.floor(self.t * v / 10) %4)
    
    local rect = self.rect:copy()
    game_tiles_hit(scene,self)
    
    if rect.x ~= self.rect.x then self.dx = -self.dx end
    if rect.y ~= self.rect.y then self.dy = -self.dy end
    self.t = self.t + t
    
    if self.rect:colliderect(scene.player.rect) then
        scene.player:kill()
    end
end
