require("tilevid")


function level_hud_draw(scene)
    cuz.view_set(0,0,GAME.SW,GAME.SH)

    local fz = 0
    local font = "gfont"
    local z = 16
    
    local s = scene.player.g_coins.."/"..scene.player.g_total
    cuz.image_draw("potato",0,0,z,z);
    GAME.font:draw(s,z+z/4,0)

    local s = tostring(scene.player.g_deaths)
    local ww = cuz.font_size("font",z,s)
    GAME.font:draw(s,(GAME.SW-ww)/2,0)
    cuz.image_draw("skull",(GAME.SW-ww)/2-(z+4),0,z,z)
    
    local ts = round(scene.player.g_time*100)
    local tm = math.floor(ts/6000)
    ts = math.floor(ts%6000)
    tz = math.floor(ts%100)
    ts = math.floor(ts/100)
    local s = string.format("%d:%02d.%02d",tm,ts,tz)
    local ww = cuz.font_size("font",z,s)
    GAME.font:draw(s,(GAME.SW-ww),0)
    cuz.image_draw("clock",(GAME.SW-ww)-(z+4),0,z,z)
end


function level_win_draw(scene,t)
    cuz.view_set(0,0,GAME.SW,GAME.SH)

    local fz = 16
    local font = "gfont"
    local z = 16
    local zw = z+8
    
    local x = GAME.SW/2 - (12)
    local y = (GAME.SH-fz*5)/2
    
    local img = "cranberry"
    local alt = "black"
    if scene.player.g_bonus > 0 then alt = "cranberry-1" end
    if ((t*2)%2) > 0.5 then img = alt end
    cuz.image_draw(img,x-8,GAME.SH-(24+16+4),24+16,24+16)

    local ts = round(scene.player.g_time*100)
    local tm = math.floor(ts/6000)
    ts = math.floor(ts%6000)
    tz = math.floor(ts%100)
    ts = math.floor(ts/100)
    local s = string.format("%d:%02d.%02d",tm,ts,tz)
    local ww = GAME.font:size(s)
    cuz.image_draw("clock",x-zw,y,z,z);
    GAME.font:draw(s,x,y)
    y = y + fz*3/2
    
    local s = scene.player.g_coins.."/"..scene.player.g_total
    local ww = GAME.font:size(s)
    cuz.image_draw("potato",x-zw,y,z,z);
    GAME.font:draw(s,x,y)
    y = y + fz*3/2

    local s = tostring(scene.player.g_deaths)
    local ww = GAME.font:size(s)
    cuz.image_draw("skull",x-zw,y,z,z);
    GAME.font:draw(s,x,y)
    
    local s = "LEVEL "..tostring(GAME.cur).." COMPLETED"
    local ww = GAME.font:size(s)
    GAME.font:draw(s,(GAME.SW-ww)/2,4)
    
    
end

function level_init()
    GAME.level = GAME.level or {}
    ---------------------------------------------------------------------

    GAME.modules.level_play = GAME.modules.level_play or {}
    local obj = GAME.modules.level_play
    function obj:init()
        self.t = 0
        self.nt = 0
    end
    function obj:event(e)
--         print(e.type..":"..e.button..":"..e.x..","..e.y.." "..e.dx..","..e.dy)
        if e.type == 'keydown' and e.name == 'Escape' then 
            game_quit()
        end
        GAME.level.scene:event(e)
    end
    function obj:loop(t)
        self.t = self.t + t
        local inc = 1.0/60.0
        while self.nt < self.t do
            GAME.level.scene:loop(inc)
            self.nt = self.nt + inc
        end
    end
    function obj:paint()
        GAME.level.scene:draw()
        
        local scene = GAME.level.scene
        level_hud_draw(scene)
        cuz.view_set(scene.view.x,scene.view.y,scene.view.w,scene.view.h)

    end

    ---------------------------------------------------------------------
    
    GAME.modules.level_win = GAME.modules.level_win or {}
    local obj = GAME.modules.level_win
    function obj:init()
        self.t = 0
        
    end
    function obj:event(e)
        if e.type == 'keydown' and (e.name == 'Escape' or e.name == 'Space') then 
            game_next()
        end
    end
    function obj:loop(t)
        self.t = self.t + t
    end
    function obj:paint()
--         GAME.level.scene:draw()

        local scene = GAME.level.scene
        level_win_draw(scene,self.t)
        cuz.view_set(scene.view.x,scene.view.y,scene.view.w,scene.view.h)

    end

end