require("util")
require("tilevid")

require("codes")

function mk_tile(icon,data)
    local r = Tile(icon)
    r.icon = icon
    if data ~= nil then for k,v in pairs(data) do r[k] = v end end
    return r
end

function add_tile(T,...)
    push(T,mk_tile(...))
end

function tiles_init()
    GAME.tiles = GAME.tiles or {}
    local T = GAME.tiles
    while #T > 0 do pop(T) end
    
    T[0] = mk_tile("blank")
    add_tile(T,"code-edge",{edge=true})
    add_tile(T,"block",{top=true,right=true,bottom=true,left=true})
    add_tile(T,"item-coin",{skip=true,coin=true})
    add_tile(T,"stripes")
    add_tile(T,"block-lower",{skip=true})
    add_tile(T,"turkey-0",{code_init=Turkey_new})
    add_tile(T,"cornucopia",{goal=true,frames={'cornucopia-0','cornucopia-1'},duration=0.25})
    add_tile(T,"axe-0",{code_init=Axe_new,dx=-1,dy=0})
    add_tile(T,"code-animate",{code_init=Animate_new})
    add_tile(T,"code-edge-solid",{edge=true,top=true,right=true,bottom=true,left=true})
    add_tile(T,"cranberry",{bonus=true,frames={'cranberry','cranberry-1'},duration=0.25})
    add_tile(T,"potato",{coin=true,frames={'potato','potato-1'},duration=0.25})
    add_tile(T,"fake")
    add_tile(T,"code-spawn",{skip=true,code=true,spawn=true})
    add_tile(T,"code-edge-death",{edge=true,kill=true})
    add_tile(T,"axe-1",{code_init=Axe_new,dx=0,dy=1})
    add_tile(T,"axe-2",{code_init=Axe_new,dx=1,dy=0})
    add_tile(T,"axe-3",{code_init=Axe_new,dx=0,dy=-1})
    add_tile(T,"b-corner",{top=true,right=true,bottom=true,left=true})
    add_tile(T,"b-horz",{top=true,right=true,bottom=true,left=true})
    add_tile(T,"b-vert",{top=true,right=true,bottom=true,left=true})
    add_tile(T,"block2",{top=true,right=true,bottom=true,left=true})
    add_tile(T,"block3",{top=true,right=true,bottom=true,left=true})
    add_tile(T,"block4",{top=true,right=true,bottom=true,left=true})
    add_tile(T,"b-corner3",{top=true,right=true,bottom=true,left=true})
    add_tile(T,"b-horz3",{top=true,right=true,bottom=true,left=true})
    add_tile(T,"b-vert3",{top=true,right=true,bottom=true,left=true})
    add_tile(T,"b-corner4",{top=true,right=true,bottom=true,left=true})
    add_tile(T,"b-horz4",{top=true,right=true,bottom=true,left=true})
    add_tile(T,"b-vert4",{top=true,right=true,bottom=true,left=true})
  
end